/*

    Till Harbaum

    t.harbaum@tu-bs.de
    http://www.ibr.cs.tu-bs.de/
*/


#include <Pilot.h>
#include "accel_testRsc.h"

extern void getvals(short *vals);

/////////////////////////
// Function Prototypes
/////////////////////////

static void    StartApplication(void);
static Boolean MainFormHandleEvent(EventPtr event);
static Boolean ApplicationHandleEvent(EventPtr event);
static void    EventLoop(void);

char tmp[32];

#include "adxl202.h"

static void StartApplication(void)
{
  adxl202_setup();

  SysTaskDelay(100);

  adxl202_zero();

  FrmGotoForm(frm_Main);
}

static Boolean MainFormHandleEvent(EventPtr event)
{
  Boolean handled = false;
  int i;

  switch (event->eType) {
  case frmOpenEvent:
    FrmDrawForm(FrmGetActiveForm());

    handled = true;
    break;
  }

  return(handled);
}

/////////////////////////
// ApplicationHandleEvent
/////////////////////////

static Boolean ApplicationHandleEvent(EventPtr event)
{
  FormPtr form;
  Word    formId;
  Boolean handled = false;
  
  if (event->eType == frmLoadEvent) {
    formId = event->data.frmLoad.formID;
    form = FrmInitForm(formId);
    FrmSetActiveForm(form);
    
    switch (formId) {
    case frm_Main:
      FrmSetEventHandler(form, MainFormHandleEvent);
      break;
    }
    handled = true;
  }

  return handled;
}

/////////////////////////
// EventLoop
/////////////////////////

#define TICKSWAIT 100

static void EventLoop(void)
{
  EventType event;
  Word      error, count=0;
  Word  ticks_wait;
  long  last_ticks=0;
  int x,y;

  /* initialize Timer */
  ticks_wait = SysTicksPerSecond()/10;

  do {
    EvtGetEvent(&event, ticks_wait);

    if (SysHandleEvent(&event))
      continue;
    if (MenuHandleEvent(NULL, &event, &error))
      continue;
    if (ApplicationHandleEvent(&event))
      continue;

    /* do some kind of timer event */
    if(TimGetTicks()>last_ticks) {

      adxl202_get(&x, &y);

      StrPrintF(tmp, "%d   %d   ", x, y);
      WinDrawChars(tmp, StrLen(tmp), 0, 20);

      last_ticks=TimGetTicks()+ticks_wait;
    }

    FrmDispatchEvent(&event);
  } while (event.eType != appStopEvent);
  
  adxl202_exit();
}

/////////////////////////
// PilotMain
/////////////////////////

DWord PilotMain(Word cmd, Ptr cmdBPB, Word launchFlags)
{
    if (cmd == sysAppLaunchCmdNormalLaunch)
    {
        StartApplication();
        EventLoop();
        return(0);
    }
    return(0);
}













